package uk.ac.ox.tall.wcker;

import java.io.File;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.wizard.Wizard;

import uk.ac.ox.tall.wcker.GenericWckerPage;
import uk.ac.ox.tall.wcker.NeedToKnow;

public class BuildWizard extends Wizard
{
	static boolean debug = WckerSystem.doDebug();
	NeedToKnow ntn;
	private ISelection selection;
	
	public BuildWizard(NeedToKnow ntn_arg) {
		super();
		ntn = ntn_arg;
		setWindowTitle(ntn.title + " - WCKER");
		setNeedsProgressMonitor(true);
	}
	
	public void addPages() {
		//TODO: set number of pages from number of steps in ntk
		for(int i=1;i<=4;++i)
		{
			GenericWckerPage p = new GenericWckerPage(selection, ntn,i);
			addPage(p);
		}
	}

    public boolean performFinish() {
    	//TODO: Export to IMS CP
        return true;
    }

    public boolean performCancel() {
if (debug )
{
		System.out.println("try delete: ");
}
		//TODO: Maybe move this functionality to a different class.
		//Get the directory we're working in
		File workingDir = ntn.getInitialDir();

		// Temporary arangement to delete working files
		//MessageDialog dialog = new 
		//boolean saveChanges = dialog.openConfirm(this.getShell(), "Save progress", "You have unsaved changes. Do you wish to save them?");

		if (debug )
		{
			System.out.println("Delete: " + workingDir);
			System.out.println("Did delete work? " + workingDir.delete());
		}
		
    		//Disabled until we can get it up and running properly. 
    		//TODO: ask about whether to save progress or not.
    		//ContentPackage cp = ntn.cp;
    		/*
    		if (ntn.getWorkingDir().equals(ntn.getInitialDir())) {
        		System.out.println("Not moved from initialDir");
    			//If progress has not been saved/exported to a directory
    			//Ask the user if they want to save their progress

    			
    			//If they want to save, give them a directory dialogue, to indicate where to save.
    			//Copy the workingDir copy to the user-chosen directory

    			
    			//If they don't want to save
    			//Delete the work in progress
    		} else if (cp.isDirty()) {
    			System.out.println("Has moved from initialDir");
    			//Check if CP is "dirty" (ie has changed)
    			//Ask the user if they want to save their progress
    			//If they want to save, save


    			//If they don't want to save
    			//Exit without making any changes.
    		}
    		*/

        return true;
    }
}
