package uk.ac.ox.tall.wcker;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;

class PreviousNext extends Composite
{
	Button button5;
	Button button6;
	static boolean debug = WckerSystem.doDebug();
	NeedToKnow local_ntn;
	/*********************************************************************************************/
	/**
	* makes an array of buttons all the same size.
	* i.e. making these all the same size as the largest
	* @param b the input arrray of buttons
	*/
	public void n_buttons(Button[] b)
	{		
		int x = ( b[0].getSize() ).x; 
		int y = ( b[0].getSize() ).y;
		
		for(int i=1;i<b.length;++i)
		{
			int x2 = ( b[i].getSize() ).x; 
			int y2 = ( b[i].getSize() ).y;
			x = (x > x2) ? x : x2; 
			y = (y > y2) ? y : y2; 
		}
		for(int i=0;i<b.length;++i)
		{
			// b[i].setSize( 100, 40);
			GridData gridData = new GridData();
			gridData.heightHint = 50;
			gridData.widthHint = 50;
			gridData.heightHint = y;
			gridData.widthHint = x;
			Object o = b[i].getLayoutData();
			if ( debug )
			{
				System.out.println("o = |" + o + "|");
			}
			GridData gridData_in = (GridData) o;
			gridData_in.heightHint = y;
			gridData_in.widthHint = x;
			b[i].setLayoutData(gridData_in);
			b[i].pack();
		}
	}
	/**
	* makes two buttons the same size
	* i.e. making the smaller the same size as the larger
	* @param b0 the first button
	* @param b1 the second button
	*/
	void two_buttons(Button b0,Button b1)
	{
		n_buttons(  new Button[] { b0, b1} );
	}

	/***************************************************************************/
	PreviousNext(Composite parent, int style, NeedToKnow local_ntn_arg) // parent holds tree&questions + buttons
	{									// parent is grid
		super(parent,style);
		local_ntn = local_ntn_arg;
		previous_and_next(this);
	}
	void disable_two( MyTreeItem ti)
	{
		button5.setEnabled(    which_way_is_UP_from_here(ti) != null );
		button6.setEnabled(  which_way_is_DOWN_from_here(ti) != null );
	}
	void disable_all( )
	{
		button5.setEnabled( false );
		button6.setEnabled(  false );
	}
	/***************************************************************************/
	TreeItem which_way_is_down_from_here(TreeItem ti)
	{
		if ( ti.getExpanded() )
		{
			return get_first_daughter( ti);
		}
		else 
		{
			return get_next_sister(ti);
		}
	}
	TreeItem which_way_is_DOWN_from_here(TreeItem ti)
	{
					TreeItem next_selection;
					try
					{
						return get_first_daughter( ti );
					}
					catch ( Exception ex )
					{
						return  get_next_sister(ti );
					}


/***
		if ( ti.getExpanded() )
		{
			return get_first_daughter( ti);
		}
		else 
		{
			return get_next_sister(ti);
		}
*****/
	}
	TreeItem which_way_is_UP_from_here(TreeItem ti)
	{
		return get_PREV_sister(ti);
	}

	TreeItem get_PREV_sister(TreeItem ti)
	{
		TreeItem p = ti.getParentItem();
		if ( p != null )
		{
			TreeItem[] d = p.getItems(); 
			int sister = -1;
			for ( int i = 0 ; i < d.length; ++i)
			{
				if ( ti == d[i] )
				{
					sister = i - 1;
				}
			}
			if ( sister < 0 )
			{
				return p;
			}
			else
			{
				// does sister have chidren
				
				try
				{
					return get_last_daughter( d[sister] );
				}
				catch (Exception exc )
				{
					return d[sister];
				}
			/***
				if ( d[sister].getExpanded()  )
				{
					
					return get_last_daughter( d[sister] );
				}
				else
				{
					return d[sister];
				}
			****/

			}
		}
		return p;
	}

	TreeItem get_last_daughter(TreeItem ti)
	{
		TreeItem[] d2 = ti.getItems(); 
		return d2[d2.length - 1];
	
	}
	TreeItem get_prev_sister(TreeItem ti)
	{
		TreeItem p = ti.getParentItem();
		if ( p != null )
		{
			TreeItem[] d = p.getItems(); 
			int sister = -1;
			for ( int i = 0 ; i < d.length; ++i)
			{
				if ( ti == d[i] )
				{
					sister = i - 1;
				}
			}
			if ( sister < 0 )
			{
				return p;
			}
			else
			{
				if ( d[sister].getExpanded() )
				{
					return get_last_daughter( d[sister] );
				}
				else
				{
					return d[sister];
				}
			}
		}
		return p;
	}
	TreeItem get_first_daughter(TreeItem ti)
	{
		return ( ti.getItems() )[0];
	
	}
	TreeItem get_next_sister(TreeItem ti)
	{
		TreeItem p = ti.getParentItem();
		if ( p != null )
		{
			TreeItem[] d = p.getItems(); 
			int sister = d.length;
			for ( int i = 0 ; i < d.length; ++i)
			{
				if ( ti == d[i] )
				{
					sister = i + 1;
				}
			}
			if ( sister >= d.length )
			{
				return get_next_sister(p);
			}
			else
			{
				return d[sister];
			}
		}
		return p;
	}
	/***************************************************************************/
	void previous_and_next(Composite c)
	{
		
		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 1;
		c.setLayout(gridLayout);


		Composite two = previous_and_next_alone(c);
		GridData g = new GridData( GridData.HORIZONTAL_ALIGN_END); 
		two.setLayoutData( g );
		
	}

	Composite previous_and_next_alone(Composite parent)
	{
		Composite c = new Composite(parent,  SWT.NONE);

		
		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		c.setLayout(gridLayout);

		button5 = new Button(c, SWT.PUSH); // BUTTON
		button5.setText("Previous Item");	
		button5.pack();
		{
			GridData gridData= new GridData();
			button5.setLayoutData(gridData);		
		}

		button5.addSelectionListener
		(
			new SelectionListener()
			{
				/*
					TRAVERSING DOWN THE SCREEN
					if we hit "Next Item" we move to next tree
                                        item in a depth first manner. If current item
					is NOT expanded then we expand it
     
				 */



				public void widgetSelected(SelectionEvent e) {
				
					if ( debug )
					{
						System.out.println("Button 5 Selection Event");
					}

///////////////////////////////////////////////////////////////////////////////
				TreeItem[] ti = local_ntn.gui_tree.getSelection();
				if ( ti.length > 0 )
				{
					TreeItem next_selection = which_way_is_UP_from_here(ti[0]);

					if ( next_selection != null )
					{
						local_ntn.select_and_see( next_selection);

		Wizard.update_title_from_tree_item( local_ntn, next_selection);
		local_ntn.tbs.update_6_buttons( local_ntn, next_selection);

					}
				}
				
				
///////////////////////////////////////////////////////////////////////////////

				}
				public void widgetDefaultSelected(SelectionEvent e) {
					if ( debug )
					{
						System.out.println("Button 5 Default Selection Event");

					}
				}
				
			}
		);


		button6  = new Button(c, SWT.PUSH); // BUTTON
		button6.setText("Next Item");
		button6.pack();
		{
			GridData gridData= new GridData();
			button6.setLayoutData(gridData);
			
		}
		button6.addSelectionListener
		(
			new SelectionListener()
			{
				public void widgetSelected(SelectionEvent e) {
					if ( debug )
					{
						System.out.println("Button 6 Selection Event");
					}
///////////////////////////////////////////////////////////////////////////////
				TreeItem[] ti = local_ntn.gui_tree.getSelection();
				if ( ti.length > 0 )
				{
					TreeItem next_selection = which_way_is_DOWN_from_here(ti[0]);

					if ( next_selection != null )
					{
						local_ntn.select_and_see(next_selection);
		Wizard.update_title_from_tree_item( local_ntn, next_selection);
		local_ntn.tbs.update_6_buttons( local_ntn, next_selection);
					}
				}
				
				
///////////////////////////////////////////////////////////////////////////////

				}
				public void widgetDefaultSelected(SelectionEvent e) {
					if ( debug )
					{
						System.out.println("Button 6 Default Selection Event");
					}
				}
				
			}
		);

			

		two_buttons(button5,button6);
		return c;
	}
	static void main(String[] args)
	{
		System.out.println("main method in PreviousNext");
	}
}
