package uk.ac.ox.tall.wcker;

import uk.ac.ox.tall.wcker.MyTreeItem;
import uk.ac.ox.tall.wcker.OrganisationPayLoad;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;
import uk.ac.ox.tall.wcker.WckerIcon;
import uk.ac.ox.tall.wcker.TreeNavigate;

import java.util.Calendar;

class TreeAction
{
	static boolean debug = WckerSystem.doDebug();
	static String get_time_stamp()
	{		
		Calendar c = Calendar.getInstance();
		//String hh_mm = ( new Date()).getTime()
		String hh_mm = c.get(	Calendar.HOUR_OF_DAY ) + ":" + c.get(Calendar.MINUTE ) + ":" + c.get(Calendar.SECOND );
		return hh_mm;
	}
	static void insert(NeedToKnow local_ntn, String type, String[] menu_item_names, boolean self_insertion_mode )
	{
		/*
			we need to find the currently selected node and get the index of the menu_item
			how do we know whether we are inserting in the current OR inserting in the parent

	 	*/	
		
		TreeItem[] tis = local_ntn.gui_tree.getSelection();
		if ( tis.length > 0 )
		{
			MyTreeItem ti =  (MyTreeItem) tis[0];
			WckerTree wt  = (WckerTree) ti.payload;

			MyTreeItem where_does_it_go;	
			
			if ( self_insertion_mode )
			{
				where_does_it_go = ti;
				if (where_does_it_go.getExpanded() == false )
				{
					where_does_it_go.setExpanded(true);
				}
			}
			else // parent insertion mode
			{
				where_does_it_go = (MyTreeItem) ti.getParentItem();	
			}

			//String type = 	mi.getText().substring(4);
			String name =   type + " added " +  get_time_stamp();
			String arg[] = { name,  type,"", "", "" };
			OrganisationPayLoad o = new OrganisationPayLoad(arg);

			WckerTree parent_wt = (WckerTree) where_does_it_go.payload;
			WckerTree wt2 = new WckerTree ( parent_wt ,  (Object) o );
/**just copy children shouls make no difference rather than break it **/
{
			int old_length = parent_wt.children.length;
			WckerTree children[] = new WckerTree[ old_length + 1];
			for(int i =0; i < old_length ; ++i)
			{
				children[i] = parent_wt.children[i];
			}

			//WckerTree extra_one = parent_wt.children[0]; // add beginning on to end
			WckerTree extra_one = wt2;

//System.out.print("airnimal wt2.parent.hashCode() = " + wt2.parent.hashCode() + " parent_wt.children[0].parent.hashCode() = " + parent_wt.children[0].parent.hashCode());
			children[old_length] = extra_one;
			parent_wt.children = children; 
}
/*****/
if ( debug )
{
System.out.println("NEW MyTreeItem name=" + name + " type=" + type + " self_insertion_mode=" + self_insertion_mode);
}
			MyTreeItem mti = new MyTreeItem( where_does_it_go, (Object) wt2, SWT.NONE);

			mti.setText(name);
			mti.setImage( WckerIcon.my_tree_item_to_image( local_ntn, mti ));
			
			local_ntn.select_and_see(mti); // does any necessary scrolling
		}

	}
	static void gui_only_insert_success(NeedToKnow local_ntn, String type, String[] menu_item_names, boolean self_insertion_mode )
	{
		/*
			we need to find the currently selected node and get the index of the menu_item
			how do we know whether we are inserting in the current OR inserting in the parent

	 	*/	
		
		TreeItem[] tis = local_ntn.gui_tree.getSelection();
		if ( tis.length > 0 )
		{
			MyTreeItem ti =  (MyTreeItem) tis[0];
			MyTreeItem where_does_it_go;	
			
			if ( self_insertion_mode )
			{
				where_does_it_go = ti;
				if (where_does_it_go.getExpanded() == false )
				{
					where_does_it_go.setExpanded(true);
				}
			}
			else // parent insertion mode
			{
				where_does_it_go = (MyTreeItem) ti.getParentItem();	
			}

			//String type = 	mi.getText().substring(4);
			String name =   type + " added " +  get_time_stamp();
			String arg[] = { name,  type,"", "", "" };
			OrganisationPayLoad o = new OrganisationPayLoad(arg);

			WckerTree wt = new WckerTree ( (WckerTree) where_does_it_go.payload ,  (Object) o );
if (debug )
{
System.out.println("NEW MyTreeItem name=" + name + " type=" + type + " self_insertion_mode=" + self_insertion_mode);
}

			MyTreeItem mti = new MyTreeItem( where_does_it_go, (Object) wt, SWT.NONE);

			mti.setText(name);
			mti.setImage( WckerIcon.wcker_tree_to_image( local_ntn, wt ));
			
			local_ntn.select_and_see(mti); // does any necessary scrolling
		}

	}
	static void insert_failure(NeedToKnow local_ntn, MenuItem mi, String[] menu_item_names, boolean self_insertion_mode )
	{
		/*
			we need to find the currently selected node and get the index of the menu_item
			how do we know whether we are inserting in the currentOR inserting in the parent
	 	*/	
		
		TreeItem[] tis = local_ntn.gui_tree.getSelection();
		if ( tis.length > 0 )
		{
			MyTreeItem  where_does_it_go_ti  =  (MyTreeItem) tis[0];
			WckerTree   where_does_it_go_wt  =  (WckerTree)  where_does_it_go_ti.payload;		/* lets start manipulation in other domain */	
			
			if ( self_insertion_mode )
			{
				if (where_does_it_go_ti.getExpanded() == false )
				{
					where_does_it_go_ti.setExpanded(true);
				}
			}
			else // parent insertion mode
			{
				where_does_it_go_wt = where_does_it_go_wt.parent;	
				where_does_it_go_ti = (MyTreeItem) ( where_does_it_go_ti.getParentItem());
			}

			String type = 	mi.getText().substring(4);

			String name =   type + " added " +  get_time_stamp();
			String arg[] = { name,  type,"", "", "" };
			OrganisationPayLoad o = new OrganisationPayLoad(arg);


			WckerTree wt = new WckerTree ( where_does_it_go_wt,  (Object) o );
{
			int n_children = where_does_it_go_wt.children.length;
			WckerTree[] new_children = new WckerTree[ n_children + 1];
			for(int i = 0; i < n_children; ++i)
			{
				new_children[i] = where_does_it_go_wt.children[i];
			}
			new_children[n_children] = wt;
			where_does_it_go_wt.children = new_children;
}

if (debug )
{
System.out.println("NEW MyTreeItem name=" + name + " type=" + type + " self_insertion_mode=" + self_insertion_mode);
}

			MyTreeItem mti = new MyTreeItem( where_does_it_go_ti, (Object) wt, SWT.NONE);

			mti.setText(name);
			mti.setImage( WckerIcon.wcker_tree_to_image( local_ntn, wt ));

			local_ntn.select_and_see(mti); // DOES NOT UPDATE BUTTONS HERE ZZZ
			
			// does any necessary scrolling
		}

	}
	static void gui_only_delete( NeedToKnow ntn, MyTreeItem current_item )
	{
		TreeItem next_select = TreeNavigate.which_way_is_down_from_here( (TreeItem) current_item );
		if ( next_select != null )
		{	
			ntn.select_and_see( next_select );
		}
		// select above
		current_item.dispose();
	}
	static void delete_selected(WckerTree wt)
	{
		if ( wt.selected )
		{
			WckerTree[] old_children = wt.parent.children;
			int n_children      =  old_children.length ; // number of new children
			
			wt.parent.children = new WckerTree[n_children - 1];

			int dst = 0;
			for(int i = 0; i < n_children ; ++i)
			{
				if ( old_children[i] != wt )
				{
					wt.parent.children[dst++] = old_children[i];
				}
			}
		}
		else
		{
			WckerTree[] children =  wt.children;
			for(int i = 0; i < children.length ; ++i)
			{
				delete_selected(children[i]);
			}
		}


	}
	static void delete( NeedToKnow ntn, MyTreeItem current_item )
	{
		TreeItem next_select = TreeNavigate.which_way_is_down_from_here( (TreeItem) current_item );

		// get expanded and selected info in secular mode

		TreeNavigate.collect_expanded_status_top(ntn);
		TreeNavigate.collect_selected_status_top(ntn, current_item);
		
		// this should do a null operation -b ut re-inserting expansion and selection!!!!!
		 // WT -> TI
			ntn.gui_tree.deselectAll() ;
			ntn.gui_tree.removeAll();

		delete_selected( ntn.organization.children[0] );
		if ( next_select != null )
		{
			( (WckerTree) ( ( (MyTreeItem)next_select).payload)).selected = true;
		}

		MyTreeItem mti = Convert.wcker_tree_to_my_tree_item( ntn, ntn.gui_tree, ntn.organization.children[0] );

/**
		TreeItem[] ti = ntn.gui_tree.getItems();
		if ( ti.length > 0 )
		{
			ti[0].dispose();
		}
***/
		//MyTreeItem mti = Convert.wcker_tree_to_my_tree_item( ntn, ntn.gui_tree, ntn.organization.children[0] );

/*****
		TreeItem next_select = TreeNavigate.which_way_is_down_from_here( (TreeItem) current_item );
		if ( next_select != null )
		{	
			ntn.select_and_see( next_select );
		}
		// select above
		current_item.dispose();
*******/

	}
}
