package uk.ac.ox.tall.wcker;
import org.eclipse.swt.SWT;

import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.custom.StyledText;

class WckerBrowser
{
	Browser b;
	StyledText st;
	String os_name = System.getProperty("os.name");
	boolean browser_fail = os_name.equals("Linux") ;
	static boolean debug = WckerSystem.doDebug();
	
	WckerBrowser(Composite parent, int style)
	{
		if ( debug )
		{
			System.out.println("os_name = " + os_name);
		}
		
		if ( browser_fail )
		{
			st = new StyledText(parent, (SWT.READ_ONLY &(~ SWT.BORDER)) | SWT.H_SCROLL );
		}
		else
		{
			b = new Browser(parent, style);
		}

	
	} 
	void setText(String contents)
	{
		if ( browser_fail )
		{
			st.setText(contents);
		}
		else
		{
			b.setText(contents);
		}
	}
	public void setLayoutData(Object layoutData)
	{
		if ( browser_fail )
		{
			st.setLayoutData(layoutData);
		}
		else
		{
			b.setLayoutData(layoutData);
		}
	}
}

