package uk.ac.ox.tall.wcker;

/**
 * WckerQuestionGroup class - represents the <questionGroup> element in the XML
 *                            forms part of the NeedToKnow object
 * @author BalchD
 * @author JohnstonD
 *  
 */

public class WckerQuestionGroup
{
	String id = "";
	WckerQuestion[] questions;
	public String toString()
	{
		String acc = "";
		acc += "ID: " + id;
		for (int i = 0;i < questions.length;++i)
		{
			acc += questions[i];
		}
		return acc;
	}
	public WckerQuestionGroup dup()
	{
		WckerQuestionGroup wqg = new WckerQuestionGroup();
		wqg.id = new String(id);
		wqg.questions = new WckerQuestion[ questions.length ];
		for(int i = 0; i <  questions.length ; ++i)
		{
			wqg.questions[i] = questions[i].dup();
		}
		return wqg;
	}
}
