package uk.ac.ox.tall.wcker;
/**
 * WckerStep class - represents the <step> element in the XML
 *                   forms part of the NeedToKnow object
 * @author BalchD
 * @author JohnstonD
 *  
 */

public class WckerStep 
{
	String title;
	String plaintext;		// top-level plaintext
	String guidance;		// inner plaintext
	String structure_guidance;
	String structure_prompt;
	String apply_name;
	String action;
	String questionGroup_ref;

	
	WckerQuestionGroup wqg; // a unique copy of Question Group to modify at will!!!!

	/**
	 * produces textual dump of WckerStep object for debugging purposes
	 *
	 * @return textual dump as a String
	 */

	public String toString()
	{
		String acc = "";
		acc += "TITLE: " + title + "\n";
		acc += "GUIDANCE: " +  guidance + "\n";
		acc += "QUESTIONGROUP_REF: " + questionGroup_ref + "\n";
		return acc;
	}
}
