package uk.ac.ox.tall.wcker;
class WckerUtility
{
	static String string_list_list(String[][] l )
	{
		String acc = "";
		for(int i = 0 ; i < l.length; i++ )
		{
			acc += string_list_to_path(l[i]) + "\n";
		}
		return acc;
	}
	static String string_list_to_path(String[] l )
	{
		if ( l.length == 0 )
		{
			return "/";
		}
		String acc = "";
		for(int i = 0 ; i < l.length; i++ )
		{
			acc += "/" + l[i];
		}
		return acc;
		
	}
	static String[][] string_3D_to_2D( String[][][] o )
	{
		int count = 0;
		for(int i = 0; i < o.length; ++i)
		{	
			count += o[i].length;
		}
		String[][] o2 = new String[count][];
		int l = 0;
		for(int i =0; i <o.length; ++i)
		{	
			for(int j =0; j < o[i].length; ++j)
			{
				
				o2[l] = o[i][j];
				l++;
			}
		}
		return o2;
	}
	static String [][] map_prepend(String word, String[][] sentences)
	{
		int n_sentences = sentences.length;

		String [][] s = new String[n_sentences][];

		for(int i = 0; i < sentences.length;++i)
		{
			s[i] = prepend(word, sentences[i]);
		}
		return s;
	}
	static String[] make_unique( String[] words_in)
	{
		int length = words_in.length;
		if ( length <= 1 )
		{
			return words_in;
		}
		// initislaise head
		String head = words_in[0];
		// initislaise tail
		String[] tail = new String[length-1];
		for(int i = 0; i < tail.length;++i)
		{
			tail[i] = words_in[i + 1];
		}
		for(int i = 0; i < tail.length;++i)
		{
			if ( head.equals( tail[i] ) )
			{
				return make_unique(tail);
			}
		}
		return prepend( head, make_unique(tail) );
		
	}
	static String [] prepend(String word, String[] old_sentence)
	{
			int n_words =  old_sentence.length;
			String [] new_sentence = new String[ n_words + 1];
			
			new_sentence[0] = word;
			for (int j = 0; j < n_words; ++j)
			{
				new_sentence[j + 1] = old_sentence[j];
			}
			return new_sentence;
	}
}
