import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory;  
import javax.xml.parsers.FactoryConfigurationError;  
import javax.xml.parsers.ParserConfigurationException;
 
import org.xml.sax.SAXException;  
import org.xml.sax.SAXParseException;  

import java.io.File;
import java.io.IOException;

import org.w3c.dom.Document;
import org.w3c.dom.DOMException;
import org.w3c.dom.*;
import org.w3c.dom.Node;
import java.util.*;


//import WizardItem;

/*
	XERCES - 
 */
public class ParseWizard
{
	
    LinkedList 	wil = new LinkedList();	// wizard item list
    WizardItem  cwi;	// current wizard item

    Document document; 
    LinkedList GetWizardList()
    {
	return wil;
    }
    String node_type_to_string(short t)
    {
		//t = org.w3c.dom.Node.ATTRIBUTE_NODE;

	switch(t)
	{
		case org.w3c.dom.Node.ATTRIBUTE_NODE:			return "ATTRIBUTE_NODE";
		case org.w3c.dom.Node.CDATA_SECTION_NODE:		return "CDATA_SECTION_NODE";
		case org.w3c.dom.Node.COMMENT_NODE:			return "COMMENT_NODE";
		case org.w3c.dom.Node.DOCUMENT_FRAGMENT_NODE:		return "DOCUMENT_FRAGMENT_NODE";
		case org.w3c.dom.Node.DOCUMENT_NODE:			return "DOCUMENT_NODE";
		case org.w3c.dom.Node.DOCUMENT_TYPE_NODE:		return "DOCUMENT_TYPE_NODE";
		case org.w3c.dom.Node.ELEMENT_NODE:			return "ELEMENT_NODE";
		case org.w3c.dom.Node.ENTITY_NODE:			return "ENTITY_NODE";
		case org.w3c.dom.Node.ENTITY_REFERENCE_NODE:		return "ENTITY_REFERENCE_NODE";
		case org.w3c.dom.Node.NOTATION_NODE:			return "NOTATION_NODE";
		case org.w3c.dom.Node.PROCESSING_INSTRUCTION_NODE:	return "PROCESSING_INSTRUCTION_NODE";
		case org.w3c.dom.Node.TEXT_NODE:			return "TEXT_NODE";
		default:						return "";
	}
}

    boolean interesting_node_type(short t)
    {
	boolean b;
	b = true;
	b = false;
		//t = org.w3c.dom.Node.ATTRIBUTE_NODE;

	switch(t)
	{
		case org.w3c.dom.Node.ATTRIBUTE_NODE:			return true;
		case org.w3c.dom.Node.CDATA_SECTION_NODE:		return true;
		case org.w3c.dom.Node.COMMENT_NODE:			return false;
		case org.w3c.dom.Node.DOCUMENT_FRAGMENT_NODE:		return true;
		case org.w3c.dom.Node.DOCUMENT_NODE:			return true;
		case org.w3c.dom.Node.DOCUMENT_TYPE_NODE:		return true;
		case org.w3c.dom.Node.ELEMENT_NODE:			return true;
		case org.w3c.dom.Node.ENTITY_NODE:			return true;
		case org.w3c.dom.Node.ENTITY_REFERENCE_NODE:		return true;
		case org.w3c.dom.Node.NOTATION_NODE:			return true;
		case org.w3c.dom.Node.PROCESSING_INSTRUCTION_NODE:	return true;
		case org.w3c.dom.Node.TEXT_NODE:			return false;
		default:						return true;
	}
/**/
	//return "";
    }
    public void navigate_node(String parent_node_name, String context, Node root)
    {
	//Element root = doc.getRootElement();
	int i;
	//Element root = doc.getDocumentElement();

//System.out.println("----------------");
//System.out.println("ROOT = " + root );
//System.out.println("----------------");

	// To get a list of all its child elements:

	//List allChildren = root.getChildren();


		Node n = root;	
		short t = n.getNodeType();
		String st = node_type_to_string(n.getNodeType()); 
		String node_name = n.getNodeName();

	if ( node_name == "wizard" )
	{
		String title 		= root.getChildNodes().item(1).getChildNodes().item(0).getNodeValue();
		String description 	= root.getChildNodes().item(3).getChildNodes().item(0).getNodeValue();
//		String title 		= "aaaaaaa";
//		String description 	=  "bbbbbbbb";
		wil.add( new WizardItem( title , description ));
System.out.println("WIZARD" + "++++++++" + title + "++++++++" + description );
		
	}


		if  (true /*interesting_node_type( t)*/ )
		{
	
			System.out.println("[" + context + "]---------------------------------");
System.out.println(	  	"PARENT_NODE NAME  = |" + parent_node_name + "|" +
				"NODE NAME  = |" + node_name + "|" +
			  	"NODE_TYPE  = |" + st +"|" +
                        	"NODE_VALUE = |" + n.getNodeValue() + "|");
			//System.out.println("child[" + i + "] = " + n);

if ( parent_node_name == "title"  || parent_node_name == "description" )
{
	
}

		}


	NodeList allChildren = root.getChildNodes();

	//System.out.println("Node list length = " + allChildren.getLength());
	if ( true )
	{
		NamedNodeMap nnm = n.getAttributes();
		if ( nnm != (NamedNodeMap) null )
		{
//System.out.println("Got some attributes" + nnm.getLength());
			for(i=0;i< nnm.getLength();++i)
			{
				int j = Character.getNumericValue('a');
				int J = 'A' + i;
				char d = (char) J;

//System.out.println("numeric value is " + j + " " + J);
				//Byte bbbb = Byte('a');
				//char[] ac = { i + 'a' };
				
				Node a = nnm.item(i);
				navigate_node( node_name, context +  d ,a );
			}
		}
	}

	for(i=0;i<allChildren.getLength();++i)
	{
		 
	//	Node n = allChildren.item(i);	

		navigate_node(  node_name, context + i, allChildren.item(i) );
/**********
		short t = n.getNodeType();
		String st = node_type_to_string(n.getNodeType()); 

		if  (interesting_node_type( t))
		{
			System.out.println("---------------------------------");
			System.out.println("NODE NAME = |" + n.getNodeName() + "|" + st + "|" );
			System.out.println("child[" + i + "] = " + n);
		}
*********/
	}

/*
	// To get just the elements with a given name:

	List namedChildren = root.getChildren("name");

	//And to get just the first element with a given name:

	Element child = root.getChild("name");
*/

    }
    public void navigate(String parent_node_name, Document doc)
    {
	//Element root = doc.getRootElement();
	int i;
	Element root = doc.getDocumentElement();

	Node n0 = (Node) root;

        navigate_node(parent_node_name, "",n0);
	return;
/********************************************************************
System.out.println("----------------");
System.out.println("ROOT = " + root );
System.out.println("----------------");

	// To get a list of all its child elements:

	//List allChildren = root.getChildren();
	NodeList allChildren = root.getChildNodes();

System.out.println("Node list length = " + allChildren.getLength());

	for(i=0;i<allChildren.getLength();++i)
	{
		 
		Node n = allChildren.item(i);	
		short t = n.getNodeType();
		String st = node_type_to_string(n.getNodeType()); 

		if  (interesting_node_type( t))
		{
			System.out.println("---------------------------------");
			System.out.println("NODE NAME = |" + n.getNodeName() + "|" + st + "|" );
			System.out.println("child[" + i + "] = " + n);
		}
	}
****************************************************************/
/*
	// To get just the elements with a given name:

	List namedChildren = root.getChildren("name");

	//And to get just the first element with a given name:

	Element child = root.getChild("name");
*/

    }

//	http://java.sun.com/xml/jaxp/change-requests-12.html
        ParseWizard(String  args)
	{
    		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    		dbf.setNamespaceAware(true);
    		 dbf.setValidating(true);
System.out.println("11111111111111111");
    		 dbf.setAttribute("http://java.sun.com/xml/jaxp/properties/schemaLanguage", 
    			           "http://www.w3.org/2001/XMLSchema");
System.out.println("222222222222222---------------");
//String schema = "http://www.example.com/Report.xsd";
String schema =  "file://home/johnstod/xerces/BookStore.xsd";
//String xml =  "BookStore.xml";
String xml =  args;

/* THIS CAUSES TROUBLE 

     		dbf.setAttribute("http://java.sun.com/xml/jaxp/properties/schemaLocation", 
    			             schema);
*/
System.out.println("333333333333333333333---------------");
		 try
		{
  System.out.println("4444444444444444---------------");
  			 DocumentBuilder db = dbf.newDocumentBuilder();
 System.out.println("5555555555555---------------");
  		 	Document doc = db.parse(xml);
			navigate("", doc);
			System.out.println( "wil len = " + wil.size());
			int i;
			for(i=0;i<wil.size();++i)
			{
				 System.out.println( i + " " + wil.get(i) );
			}
			
		}
		catch (Exception e )
		{
			System.out.println("exception" + e);
		}


 	}
	public static void main( String args[])
	{
		ParseWizard pw = new ParseWizard( args[0] );
	}

}
