import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

 class MyCellRenderer extends JLabel implements ListCellRenderer {
     final static ImageIcon longIcon = new ImageIcon("long.gif");
     final static ImageIcon shortIcon = new ImageIcon("short.gif");

     // This is the only method defined by ListCellRenderer.
     // We just reconfigure the JLabel each time we're called.

     public Component getListCellRendererComponent(
       JList list,
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // the list and the cell have the focus
     {

         String s = value.toString();
         setText(s);
//setHorizontalAlignment(SwingConstants.LEFT);
System.out.println("Renderer has string |" + s + "| index is " + index );
	 JPanel c = new JPanel();
	 JLabel l = new JLabel(s);

         setIcon((s.length() > 10) ? longIcon : shortIcon);
   	   if (isSelected) {
             setBackground(list.getSelectionBackground());
	       setForeground(list.getSelectionForeground());
         
	       l.setForeground(Color.RED);
	   }
         else {
	       setBackground(list.getBackground());
	       setForeground(list.getForeground());
	     
	       l.setForeground(Color.BLUE);
	   }
	   setEnabled(list.isEnabled());
	   setFont(list.getFont());
         setOpaque(true);
        //  return this;
	 c.add(l);
        return c;
     }

     public static void main( String s [] )
     {
            String[] data = {"one", "two", "three", "four"};
            JList dataList = new JList(data);
            dataList.setCellRenderer(new MyCellRenderer());

     }
 }

/*
 String[] data = {"one", "two", "three", "four"};
 JList dataList = new JList(data);
 dataList.setCellRenderer(new MyCellRenderer());
 */
