import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

// class MyCellRenderer extends JPanel implements ListCellRenderer {
 class MyCellRenderer extends JLabel implements ListCellRenderer {
     final static ImageIcon longIcon = new ImageIcon("long.gif");
     final static ImageIcon shortIcon = new ImageIcon("short.gif");

	Dimension acc = new Dimension(0,0);

     // This is the only method defined by ListCellRenderer.
     // We just reconfigure the JLabel each time we're called.

     
     public Component getListCellRendererComponent(
       JList list,
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // the list and the cell have the focus
     {

         String s = value.toString();
         setText(s);
	setHorizontalAlignment(SwingConstants.RIGHT); // works for text!!!!
System.out.println("Renderer has string |" + s + "| index is " + index );
	 JPanel c = new JPanel();
	 JLabel l = new JLabel(s);

///////////////////////////
	 Dimension d = l.getPreferredSize();
	 if (  d.width > acc.width )   acc.width = d.width;
	 if (  d.height > acc.height ) acc.height = d.height;
System.out.println("cell width = " + d.width + "cell height = " + d.height);
System.out.println("acc width = " + acc.width + "cell height = " + acc.height);
///////////////////////////

         setIcon((s.length() > 10) ? longIcon : shortIcon);
   	   if (isSelected) {
             setBackground(list.getSelectionBackground());
	       setForeground(list.getSelectionForeground());
         
	       l.setForeground(Color.RED);
	   }
         else {
	       setBackground(list.getBackground());
	       setForeground(list.getForeground());
	     
	       l.setForeground(Color.BLUE);
	   }
	   setEnabled(list.isEnabled());
	   setFont(list.getFont());
         setOpaque(true);

	 GridBagLayout layout = new GridBagLayout();
	  GridBagConstraints constraints = new GridBagConstraints();

	constraints.weightx = 0;
	constraints.weighty = 0;
	constraints.gridx = 0;
	constraints.gridy = 0;
	constraints.gridwidth = 1;
	constraints.gridheight = 1;
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;

	
	 c.setLayout(layout);

	 layout.setConstraints(c, constraints);
	 c.add(l); // BASIC STRING

 	 constraints.gridx = 1;
	 c.add(new JLabel("1")); // BASIC STRING

	 Box h = Box.createHorizontalBox();
	 h.add(new JLabel("a")); 
	 int difference = acc.width - d.width;
System.out.println("difference = " + difference);

	 h.add( Box.createHorizontalStrut(difference));
 	 h.add(new JLabel("b")); 

	 constraints.gridx = 2;
	 c.add(h); // BASIC STRING

	 constraints.gridx = 3;
	 c.add(new JLabel("3")); // BASIC STRING



	JPanel c2 = new JPanel();
	c2.add(c);
	c2.add(new JLabel("start"));
	c2.add(Box.createHorizontalGlue());
	c2.add(new JLabel("end"));
	
         // return this;
        return c;
       //return c2;
     }

     public static void main( String s [] )
     {
            String[] data = {"one", "two", "three", "four"};
            JList dataList = new JList(data);
            dataList.setCellRenderer(new MyCellRenderer());

     }
 }

/*
 String[] data = {"one", "two", "three", "four"};
 JList dataList = new JList(data);
 dataList.setCellRenderer(new MyCellRenderer());
 */
