// Fig. 13.14: ListTest.java
// Selecting colors from a JList.
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class ListTest extends JFrame {
   private JList colorList;
   private Container container; 
   private Container sub_container1;
   private GridBagLayout layout;
   private Font f = new Font("Helvetica", Font.PLAIN, 16);
   private Font fb = new Font("Helvetica", Font.BOLD, 14);
   private Font fn = new Font("Helvetica", Font.PLAIN, 12);
   private Color dark_blue = new Color(0,0,128 + 32);
   private Color light_blue =  new Color(128,196,255);
   private Color mid_grey =  new Color(128,128,128);
   private Color light_grey =  new Color(196,196,196);
   private Color white =  new Color(255,255,255);
   private Color orange =  new Color(255,128,0);

/*
   private final String colorNames[] = { "Black", "Blue", "Cyan", 
      "Dark Gray", "Gray", "Green", "Light Gray", "Magenta",
      "Orange", "Pink", "Red", "White", "Yellow" };
*/

/* newlines not incorporated into menus */
/*
	Lets see what  other types we can shove in a list
		
	currently JList( colorNames ); String colorNames[]

	get button to wrok
	variable sizes - do I have to go to GridBayLayout
	
*/

/*
	Add a label at the top level 
*/

  private final String colorNames[] = { "Masters module\n10 units with a structure of 5 sub-sections in each.", 
"TALL Short Course\nAn entire 5 weeks course with a guided structure to each week", 
//"a\na", 
"Basic face-to-face unit\nUsed to support a weekly face-to-face course" };

   private final Color colors[] = { Color.BLACK, Color.BLUE, Color.CYAN, 
      Color.DARK_GRAY, Color.GRAY, Color.GREEN, Color.LIGHT_GRAY, 
      Color.MAGENTA, Color.ORANGE, Color.PINK, Color.RED, Color.WHITE, 
      Color.YELLOW };



   // set up GUI

   private Container wcker_panel()
   {
	JPanel sub_container1;
	Dimension rv1 = new Dimension();
        Box horizontal = Box.createHorizontalBox();
        Box vertical = Box.createVerticalBox();

	JLabel j1 = new JLabel("wcker", SwingConstants.RIGHT);
	j1.setForeground(light_blue);
	j1.setBackground(dark_blue);
	j1.setToolTipText("This is label j1");
	j1.setFont(f);

	rv1 = j1.getPreferredSize();
//	System.out.println("j1 HEIGHT BEFORE is " +  rv1.height);
	rv1.height *= 1.5;
	rv1.width  *= 1;
	Component c = Box.createRigidArea(rv1);
	j1.setSize(rv1);
	rv1 = j1.getSize();
//	System.out.println("j1 HEIGHT AFTER is " +  rv1.height);

	vertical.add(Box.createVerticalStrut(rv1.height));
	vertical.add(j1);
	vertical.add(Box.createVerticalStrut(rv1.height));

	horizontal.add( Box.createHorizontalGlue() );
	horizontal.add(j1);
	horizontal.add( c );


	sub_container1  = new JPanel();
	sub_container1.setForeground(light_blue);
	sub_container1.setBackground(dark_blue);
 	sub_container1.setLayout( new GridLayout(1,1) );
 //       sub_container1.add(c);
 //       sub_container1.add(j1);
        sub_container1.add(horizontal);
	sub_container1.setSize(rv1);

	//return (JPanel) horizontal;

        return (Container)sub_container1;

   }

 
   private Container choose_a_wizard_panel()
   {
	JPanel sub_container1 = new JPanel();
        Box horizontal = Box.createHorizontalBox();
        Box vertical = Box.createVerticalBox();

	JLabel j2 = new JLabel("Choose a wizard", SwingConstants.LEFT);
	j2.setForeground(mid_grey);
	j2.setBackground(light_blue);
	j2.setToolTipText("This is label j2");
	j2.setFont(f);

	Dimension rv1 = j2.getPreferredSize();
	rv1.height *= 1;
	horizontal.add(Box.createHorizontalStrut( rv1.width / 4 ));
	horizontal.add(j2);
	horizontal.add(Box.createHorizontalGlue());
	horizontal.setForeground(light_blue);
	horizontal.setBackground(dark_blue);

//	vertical.add(new JLabel("hello"));
	vertical.add(Box.createVerticalStrut( rv1.height / 2 ));
	vertical.add(horizontal);
	vertical.add(Box.createVerticalStrut( rv1.height * 2 ));
	vertical.add(Box.createVerticalGlue());
//	vertical.add(new JLabel("world"));
	vertical.setForeground(light_blue);
	vertical.setBackground(dark_blue);

	JPanel sub_container2  = new JPanel();
	sub_container2.setForeground(mid_grey);
 	sub_container2.setBackground(light_blue);
 	sub_container2.setLayout( new GridLayout(1,1) );
        sub_container2.add(vertical);



		return (Container) sub_container2;

		//return (vertical);
   }

  private Container menu_panel()
   {
      // create a list with items in colorNames array
      colorList = new JList( colorNames );

      //colorList.setHorizontalAlignment(SwingConstants.LEADING);

      colorList.setVisibleRowCount( colorNames.length );
      
      // do not allow multiple selections
      colorList.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
////////////      colorList.setCellRenderer(new MyCellRenderer()); 

	colorList.setCellRenderer(new MyPanelRenderer());

      // add a JScrollPane containing JList to content pane

        Box horizontal = Box.createHorizontalBox();
        Box vertical = Box.createVerticalBox();
	
	horizontal.add(Box.createHorizontalStrut(25));
	horizontal.add(new JScrollPane( colorList ));
	horizontal.add(Box.createHorizontalStrut(25));

	vertical.add(Box.createVerticalStrut(25));
	vertical.add(horizontal);
	vertical.add(Box.createVerticalStrut(25));

	JPanel sub_container3  = new JPanel();
	sub_container3.setForeground(light_grey);
 	sub_container3.setBackground(light_grey);
 	sub_container3.setLayout( new GridLayout(1,1, 50, 50) );
        sub_container3.add( vertical );
        return sub_container3;
	
   }

   private class ButtonHandler implements ActionListener 
  {
      	public void actionPerformed(ActionEvent event)
      	{
		String s;

		s =  "You pressed: " + event.getActionCommand() + "\n";
		if ( colorList.getSelectedIndex() == - 1)
		{
			s =  s + "NO COURSE WIZARD SELECTED: PLEASE CHOOSE ONE";
			
		}
		else
		{
		String course = colorNames[  colorList.getSelectedIndex() ];
			s =  s + "COURSE WIZARD CHOSEN:\n" + course;
		}

		
		JOptionPane.showMessageDialog(ListTest.this,s);

		
	}
   }
  private Container select_panel()
   {
        Box horizontal = Box.createHorizontalBox();
        Box vertical = Box.createVerticalBox();

	JButton j3 = new JButton("select");
	j3.setForeground(white);
	j3.setBackground(new Color(196 -16,196 -16,196 -16) );
	j3.setToolTipText("This is button j3");
	j3.setFont(f);

	ButtonHandler handler = new ButtonHandler();

	j3.addActionListener(handler);
	
	horizontal.add(Box.createHorizontalGlue());
	horizontal.add(j3);
	horizontal.add(Box.createHorizontalStrut(25));

	vertical.add(horizontal);
	vertical.add(Box.createVerticalStrut(25));

	JPanel sub_container4  = new JPanel();
	sub_container4.setForeground(light_grey);
 	sub_container4.setBackground(light_grey);
 	sub_container4.setLayout( new GridLayout(1,1, 50, 50) );
        sub_container4.add( vertical );
	return  sub_container4;

   }
   private Container test_pad0(String s1, String s2)
   {
	JPanel p = new JPanel();
	JPanel orange_square = new JPanel();
	orange_square.setForeground(orange);
	orange_square.setBackground(orange);

	Box b =  Box.createVerticalBox();
	Box h =  Box.createHorizontalBox();
	JLabel l1 = new JLabel(s1);
	JLabel l2 = new JLabel("T");
	JLabel l3 = new JLabel(s2);
	l1.setFont(fb);
	l2.setFont(fn);
	l3.setFont(fn);


	// CREATE THREE TEXT STRINGS - ONE ABOVE THE OTHER
	b.add(l1);
	b.add(Box.createVerticalStrut(l2.getPreferredSize().height / 2));
	b.add(l3);

	Dimension rv2 = b.getPreferredSize();
	int d =  rv2.height;
System.out.println("SQUARE WIDTH " + rv2.height);

	orange_square.add(Box.createRigidArea( new Dimension(rv2.height, rv2.height)));

	orange_square.setSize(new Dimension(rv2.height, rv2.height));

	h.add( orange_square );
	h.add(Box.createHorizontalStrut(l2.getPreferredSize().width));
	h.add( b );
	h.add(Box.createHorizontalGlue());
//	h.add( new JLabel("stop_line")  );

	//p.add(new JLabel("start"));
	p.add(h);
	//p.add(new JLabel("stop"));

	p.setForeground(white);
	p.setBackground(white);
	
	return p;
   }

private Container test_pad(String s)
{
	int index;
	int length;
	int lookup;

	lookup = (int) '\n';
	index  = s.indexOf( lookup );
	length = s.length();
        System.out.println("before split");
	String a[] = s.split("\n");
        System.out.println("after split" + a[0] + a[1] );
	System.out.println("index is " + index + " length is " + length);
	return test_pad0(a[0],a[1]);
	
}

   private Container dummy_menu_antique()
   {
	int i;
	Box vertical = Box.createVerticalBox();
	GridBagLayout          layout 	=  new GridBagLayout();
	GridBagConstraints constaints   =  new GridBagConstraints();
	JPanel p = new JPanel();

	p.setLayout( layout );

	for(i=0;i<colorNames.length;++i)
	{
	
//addComponent( layout, (Container) test_pad(colorNames[i]), 0,i,1,1 , GridBagConstraints.BOTH  , 0,0);	


		vertical.add( test_pad(colorNames[i]));
	}
	return vertical;
	//return p;
   }


  private Container dummy_menu()
   {
	int i;
	Box vertical = Box.createVerticalBox();
	GridBagLayout          layout 	=  new GridBagLayout();
	GridBagConstraints constraints   =  new GridBagConstraints();
	JPanel p = new JPanel();

	p.setLayout( layout ); // we are doing grid bag */

	for(i=0;i<colorNames.length;++i)
	{
	
//addComponent( layout, (Container) test_pad(colorNames[i]), 0,i,1,1 , GridBagConstraints.BOTH  , 0,0);	


	constraints.weightx = 0;
	constraints.weighty = 0;

	constraints.gridx = 0;
	constraints.gridy = i;
	constraints.gridwidth = 1;
	constraints.gridheight = 1;
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;

	Container c = test_pad(colorNames[i]);
	layout.setConstraints(c, constraints);

		p.add( c );
	}
	p.setBackground(white);
	p.setForeground(white);
	//return vertical;
	return p;
   }

/*******/
   public ListTest()
   {

      super( "List Test" );

  //////    GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();

      // get content pane and set its layout
      container = getContentPane();
//     container.setLayout( new FlowLayout() );

 	//GridBagLayout layout  = new GridBagLayout();
	layout  = new GridBagLayout();

     container.setLayout( layout );

   
	Container sub_container1 = (Container) wcker_panel();
   	Container sub_container2 = (Container) choose_a_wizard_panel();
   	Container sub_container3 = (Container) menu_panel();
   	Container sub_container4 = (Container) select_panel();
//	Container sub_container5 = (Container) dummy_menu();



	addComponent( layout, (Container) sub_container1, 0,0,1,1 , GridBagConstraints.BOTH  , 0,0);
	addComponent( layout, (Container) sub_container2, 0,1,1,1 , GridBagConstraints.BOTH  , 0,0);
//	addComponent( layout, (Container) sub_container3, 0,2,1,1 , GridBagConstraints.BOTH  , 0,0);
	addComponent( layout, (Container) sub_container3, 0,2,1,1 , GridBagConstraints.BOTH  , 1,1);
	addComponent( layout, (Container) sub_container4, 0,3,1,1 , GridBagConstraints.BOTH  , 0,0);
//	addComponent( layout, (Container) sub_container5, 0,4,1,1 , GridBagConstraints.BOTH  , 0,0);
//	addComponent( layout, (Container) sub_container6, 0,5,1,1 , GridBagConstraints.BOTH  , 0,0);


      colorList.addListSelectionListener(

         new ListSelectionListener() {  // anonymous inner class 

            // handle list selection events
            public void valueChanged( ListSelectionEvent event )
            {
               //System.out.println("Selection Index = " + colorList.getSelectedIndex());
               container.setBackground( 
                  colors[ colorList.getSelectedIndex() ] );
            }

         } // end anonymous inner class

      ); // end call to addListSelectionListener

      setSize( 500, 800 ); // size of window
      setVisible( true );

   } // end ListTest constructor

public void addComponent(GridBagLayout layout, Container c, int x,int y,int w,int h,int f, int wx, int wy )
{
	GridBagConstraints constraints;

	constraints = new GridBagConstraints();

	constraints.weightx = wx;
	constraints.weighty = wy;

	constraints.gridx = x;
	constraints.gridy = y;
	constraints.gridwidth = w;
	constraints.gridheight = h;
	constraints.fill = f;
	layout.setConstraints(c, constraints);
	container.add(  c);
}

   public static void main( String args[] )
   { 
      ListTest application = new ListTest();
      application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
   }

} // end class ListTest

/**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and               *
 * Prentice Hall. All Rights Reserved.                                    *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
